---
title: Update ownership settings for the org
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > CSM Ownership
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Update ownership settings for the org{% #update-ownership-settings-for-the-org %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                     |
| ----------------- | ---------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/csm/ownership/settings |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/csm/ownership/settings |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/csm/ownership/settings      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/csm/ownership/settings      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/csm/ownership/settings  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/csm/ownership/settings |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/csm/ownership/settings     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/csm/ownership/settings |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/csm/ownership/settings |

### Overview

Update ownership settings for the org.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                              | Type    | Description                                                                                                                             |
| ------------ | ---------------------------------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]             | object  | The data wrapper for an ownership settings request.                                                                                     |
| data         | attributes [*required*]       | object  | The attributes of an ownership settings request.                                                                                        |
| attributes   | auto_tag [*required*]         | boolean | Whether automatic ownership tagging is enabled.                                                                                         |
| attributes   | confidence_level [*required*] | enum    | The ownership confidence level. Allowed enum values: `high,medium,low`                                                                  |
| data         | type [*required*]             | enum    | The type of the ownership settings resource. The value should always be `ownership_settings`. Allowed enum values: `ownership_settings` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "auto_tag": true,
      "confidence_level": "high"
    },
    "type": "ownership_settings"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response returned when retrieving or updating ownership settings.

| Parent field | Field                              | Type    | Description                                                                                                                             |
| ------------ | ---------------------------------- | ------- | --------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]             | object  | The data wrapper for an ownership settings response.                                                                                    |
| data         | attributes [*required*]       | object  | The attributes of the ownership settings response.                                                                                      |
| attributes   | auto_tag [*required*]         | boolean | Whether automatic ownership tagging is enabled.                                                                                         |
| attributes   | confidence_level [*required*] | enum    | The ownership confidence level. Allowed enum values: `high,medium,low`                                                                  |
| attributes   | version [*required*]          | int64   | The current version of the ownership settings.                                                                                          |
| data         | id [*required*]               | string  | The identifier of the ownership settings resource.                                                                                      |
| data         | type [*required*]             | enum    | The type of the ownership settings resource. The value should always be `ownership_settings`. Allowed enum values: `ownership_settings` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "auto_tag": true,
      "confidence_level": "high",
      "version": 1
    },
    "id": "settings",
    "type": "ownership_settings"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/csm/ownership/settings" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "auto_tag": true,
      "confidence_level": "high"
    },
    "type": "ownership_settings"
  }
}
EOF 
                
##### 

```python
"""
Update ownership settings for the org returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.csm_ownership_api import CSMOwnershipApi
from datadog_api_client.v2.model.ownership_confidence_level import OwnershipConfidenceLevel
from datadog_api_client.v2.model.ownership_settings_request import OwnershipSettingsRequest
from datadog_api_client.v2.model.ownership_settings_request_attributes import OwnershipSettingsRequestAttributes
from datadog_api_client.v2.model.ownership_settings_request_data import OwnershipSettingsRequestData
from datadog_api_client.v2.model.ownership_settings_type import OwnershipSettingsType

body = OwnershipSettingsRequest(
    data=OwnershipSettingsRequestData(
        attributes=OwnershipSettingsRequestAttributes(
            auto_tag=True,
            confidence_level=OwnershipConfidenceLevel.HIGH,
        ),
        type=OwnershipSettingsType.OWNERSHIP_SETTINGS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["post_ownership_settings"] = True
with ApiClient(configuration) as api_client:
    api_instance = CSMOwnershipApi(api_client)
    response = api_instance.post_ownership_settings(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Update ownership settings for the org returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.post_ownership_settings".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CSMOwnershipAPI.new

body = DatadogAPIClient::V2::OwnershipSettingsRequest.new({
  data: DatadogAPIClient::V2::OwnershipSettingsRequestData.new({
    attributes: DatadogAPIClient::V2::OwnershipSettingsRequestAttributes.new({
      auto_tag: true,
      confidence_level: DatadogAPIClient::V2::OwnershipConfidenceLevel::HIGH,
    }),
    type: DatadogAPIClient::V2::OwnershipSettingsType::OWNERSHIP_SETTINGS,
  }),
})
p api_instance.post_ownership_settings(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Update ownership settings for the org returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.OwnershipSettingsRequest{
		Data: datadogV2.OwnershipSettingsRequestData{
			Attributes: datadogV2.OwnershipSettingsRequestAttributes{
				AutoTag:         true,
				ConfidenceLevel: datadogV2.OWNERSHIPCONFIDENCELEVEL_HIGH,
			},
			Type: datadogV2.OWNERSHIPSETTINGSTYPE_OWNERSHIP_SETTINGS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.PostOwnershipSettings", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCSMOwnershipApi(apiClient)
	resp, r, err := api.PostOwnershipSettings(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CSMOwnershipApi.PostOwnershipSettings`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CSMOwnershipApi.PostOwnershipSettings`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Update ownership settings for the org returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CsmOwnershipApi;
import com.datadog.api.client.v2.model.OwnershipConfidenceLevel;
import com.datadog.api.client.v2.model.OwnershipSettingsRequest;
import com.datadog.api.client.v2.model.OwnershipSettingsRequestAttributes;
import com.datadog.api.client.v2.model.OwnershipSettingsRequestData;
import com.datadog.api.client.v2.model.OwnershipSettingsResponse;
import com.datadog.api.client.v2.model.OwnershipSettingsType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.postOwnershipSettings", true);
    CsmOwnershipApi apiInstance = new CsmOwnershipApi(defaultClient);

    OwnershipSettingsRequest body =
        new OwnershipSettingsRequest()
            .data(
                new OwnershipSettingsRequestData()
                    .attributes(
                        new OwnershipSettingsRequestAttributes()
                            .autoTag(true)
                            .confidenceLevel(OwnershipConfidenceLevel.HIGH))
                    .type(OwnershipSettingsType.OWNERSHIP_SETTINGS));

    try {
      OwnershipSettingsResponse result = apiInstance.postOwnershipSettings(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CsmOwnershipApi#postOwnershipSettings");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Update ownership settings for the org returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_csm_ownership::CSMOwnershipAPI;
use datadog_api_client::datadogV2::model::OwnershipConfidenceLevel;
use datadog_api_client::datadogV2::model::OwnershipSettingsRequest;
use datadog_api_client::datadogV2::model::OwnershipSettingsRequestAttributes;
use datadog_api_client::datadogV2::model::OwnershipSettingsRequestData;
use datadog_api_client::datadogV2::model::OwnershipSettingsType;

#[tokio::main]
async fn main() {
    let body = OwnershipSettingsRequest::new(OwnershipSettingsRequestData::new(
        OwnershipSettingsRequestAttributes::new(true, OwnershipConfidenceLevel::HIGH),
        OwnershipSettingsType::OWNERSHIP_SETTINGS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.PostOwnershipSettings", true);
    let api = CSMOwnershipAPI::with_config(configuration);
    let resp = api.post_ownership_settings(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Update ownership settings for the org returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.postOwnershipSettings"] = true;
const apiInstance = new v2.CSMOwnershipApi(configuration);

const params: v2.CSMOwnershipApiPostOwnershipSettingsRequest = {
  body: {
    data: {
      attributes: {
        autoTag: true,
        confidenceLevel: "high",
      },
      type: "ownership_settings",
    },
  },
};

apiInstance
  .postOwnershipSettings(params)
  .then((data: v2.OwnershipSettingsResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
